﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http.Headers;
using System.Reactive.Linq;
using System.Reactive.Threading.Tasks;
using System.Threading;
using System.Threading.Tasks;
using Dicom.Network.Client;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using NLog;

namespace SendFileWebapi.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class SCUController : ControllerBase
    {

        //[HttpPost]
        //public async Task<ActionResult> Post([FromForm]StudentModel std)
        //{
        //// Getting Name
        //string name = std.Name;
        //foreach (var img in std.Images)
        //{
        //    // Getting Image

        //    if (img.Length > 0)
        //    {
        //        using (var fileStream = new FileStream(img.FileName, FileMode.Create))
        //        {
        //            img.CopyTo(fileStream);
        //            var tt = fileStream;
        //        }

        //    }
        //}
        //return Ok(new { status = true, message = "Student Posted Successfully" });
        //} 


        static Logger logger = LogManager.GetCurrentClassLogger();

        [HttpPost]
        public async Task Post([FromForm]Models.InputsDto inputsDto)
        {
            var client = new DicomClient(inputsDto.ServerHost, inputsDto.Port, false, inputsDto.ServerAET, inputsDto.Aet);
            client.NegotiateAsyncOps();
            inputsDto.FileNames.ToObservable()
                .Select(fileName => Observable.FromAsync(async () =>
            {
                FileStream fileStream = null;
                using (var stream = new FileStream(fileName.FileName, FileMode.Create))
                {
                    await fileName.CopyToAsync(stream);
                    fileStream = stream;
                }
                var request = new Dicom.Network.DicomCStoreRequest(fileStream.Name);
                await client.AddRequestAsync(request);
                await client.SendAsync();
            }).Select(x => fileName.FileName).Catch<string, Exception>(exp => throw new Exception($"failed to send: {fileName}, with error:{exp.Message}")))
                .Concat()
                .Subscribe(
                    filename =>
                        logger.Warn($"file sent:{filename}"),
                    onError =>
                        logger.Error(onError.Message),
                    () => { });
        }

    }
}
